#include <iostream>
#include <osl/osl.h>

osl_relation_p
perforate(osl_relation_p r) {
    /* first: add one dimension */
    std::cout << "extending to " << r->nb_output_dims+1 << "\n";
    auto n = osl_relation_extend_output(r, r->nb_output_dims+1);

    /* second: find new colum */
    auto row = n->m[n->nb_rows-1];
    int col = 0;
    for(; osl_int_get_si(n->precision, row[col]) == 0 && col < n->nb_rows; col++) { }

    /* third: set equal, iterator -1, new thing 2 */
    osl_int_set_si(n->precision, &row[col], 2);
    osl_int_set_si(n->precision, &row[1], -1);
    osl_relation_dump(stdout, n);

    int x = osl_int_get_si(r->precision, row[col]);
    std::cout << "here is x: " << x << "\n";
    return n;
}

int main() {
    osl_scop_p scop;


    FILE *fp = fopen("acc.openscop", "r");
    if(!fp) {
        std::cerr << "openscop read failed\n";
        return -1;
    }
    scop = osl_scop_read(fp);
    //osl_scop_dump(stdout, scop);
    
    for(auto s = scop->statement; s; s = s->next) {
        auto d = s->domain;
        
        osl_relation_dump(stdout, d);
        auto n = perforate(d);
        s->domain = n;

        osl_relation_free(d);

    }


    // Dump the content of the scop data structure.
    //osl_scop_dump(stdout, scop);
    // Save the planet.
    osl_scop_free(scop);
}
